import 'dart:io';
import 'dart:convert';
import 'dart:async';
import 'package:dart_config/default_server.dart';

const String buildGradleFile = "android/app/build.gradle";

main(List<String> arguments) {
  Future<Map> conf = loadConfig("pubspec.yaml");
  conf.then((Map config) {
    if (config['flutter_version']['version_string'] != null) {
      //validate version
      if(isValidVersion(config['flutter_version']['version_string'])) {
        //update android build.gradle
        updateAndroid(config['flutter_version']['version_string']);
        //update ios Info.plist

      }
    } else {
      print("No version config found in pubspec.yaml");
    }
  });
}

bool isValidVersion(String s) {
  RegExp ex = new RegExp(r"^\d+.\d+.\d+$");
  return ex.hasMatch(s);
}

updateAndroid(String versionString) {

    final file = new File(buildGradleFile);
    Stream<List<int>> inputStream = file.openRead();

    inputStream.transform(UTF8.decoder).transform(new LineSplitter()).listen((String line) {
      //find version code
      if(line.trim().startsWith("versionCode")) {
        print(line);
        int versionCode = int.parse(line.split(" ").elementAt(1));
        print("Found version code: " + versionCode.toString());

        //increment version code

      } else if(line.trim().startsWith("versionName")) {
        //set build name to version string
        print(line);
        print("Found version name:" + line.split(" ").elementAt(1));
      }
    });
  }